# -*- coding: utf-8 -*-
"""
Created on Thu Sep 19 10:51:59 2019

@author: amton
"""

import pandas as pd
import datetime
from .checkParameter import checkParameter


def checkDMS_abs(logger, thredds_url, filename):

    df = pd.DataFrame(columns=['Opwerking', 'Instrument',
                               'Location', 'Parameter', 'Date', 'Url', 'inRange', 'errStr'])

    checklist = pd.read_csv(filename, skiprows=0, sep=";", header=0)

    now = pd.to_datetime(pd.datetime.now().strftime('%Y-%m-%d'))

    # loop over checks
    for i in range(len(checklist)):

        opwerking = checklist['Opwerking'][i]
        inst = checklist['Instrument'][i]
        loc = checklist['Location'][i]
        parName = checklist['Parameter'][i]

        begindays = int(checklist['Begintime'][i])
        t1 = now + pd.to_timedelta(begindays, unit='d')
        enddays = int(checklist['Endtime'][i])
        t2 = now + pd.to_timedelta(enddays, unit='d')

        t = t1
        dt = checklist['Timestep'][i]

        lowerLimit = checklist['Lower'][i]
        upperLimit = checklist['Upper'][i]
        errorValue = checklist['Errorvalue'][i]

        while 1:

            if t > t2:
                break

            datestr = '{0:04}'.format(t.year) + '{0:02}'.format(t.month) + \
                '{0:02}'.format(t.day) + '{0:02}'.format(t.hour) + '0000'
            url = thredds_url + opwerking + '/'+inst+'/' + \
                loc + '/'+inst+'_' + loc + '_' + datestr + '.nc'

            inRange, errStr = checkParameter(
                url, parName, lowerLimit, upperLimit, errorValue)

            logger.info(opwerking+';'+inst+';'+loc+';'+parName +
                        ';'+url+';'+str(inRange)+';'+errStr+'\n')

            row = [opwerking, inst, loc, parName, datestr, url, str(inRange), errStr]
            df.loc[len(df)] = row

            t = t+datetime.timedelta(hours=int(dt))

    return df
